{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //Client:{routeName:'BaseController-getComboValues',table:'clients'}
            //,ClientG:{routeName:'BaseController-getComboValues',table:'clients'}
            //,Employee:{routeName:'Employee-getComboValues',table:'employees',modulename:'Employee',fieldId:'code',fieldDisplay:'name'}
            EmployeeG:{routeName:'Employee-getComboValues',table:'employees',modulename:'Employee',fieldId:'code',fieldDisplay:'name'}
            //,JobRotation:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,JobRotationG:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            ,ProductTree:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldDisplay:'name',options:{where:'O',finish:null}}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.add=false;
            //t.windowButtons.edit=false;
            const gridConfig = {
                cm: [
                    //{header: "{{ 'ClientProductionDetailSystemOut.sec'|trans }}", dataIndex: 'sec',width: 40,alias:'cpd',renderer:mj.renderer.check()},
                    {header: "{{ 'ClientProductionDetailSystemOut.tip'|trans }}", dataIndex: 'tip',width: 60,alias:'cpd'},
                    {header: "{{ 'ClientProductionDetailSystemOut.client'|trans }}", dataIndex: 'client',width: 80,filter:'single',alias:'cpd',type:'combo',store:t.extras.clients,operator:'='},
                    {header: "{{ 'ClientProductionDetailSystemOut.day'|trans }}", dataIndex: 'day', width: 70,filter:'between',alias:'cpd'},
                    {header: "{{ 'ClientProductionDetailSystemOut.jobrotation'|trans }}", dataIndex: 'jobrotation', width: 80,filter:'single',type:'combo',store:t.extras.job_rotations,alias:'cpd',operator:'='},
                    {header: "{{ 'ClientProductionDetailSystemOut.employee'|trans }}", dataIndex: 'employee_lookup_', width: 140,filter:'single', type:'combo',store:t.extras.employees,sameValueDisplay:false,alias:'cpd',operator:'='},
                    {header: "{{ 'ClientProductionDetailSystemOut.start'|trans }}", dataIndex: 'start', width: 120,alias:'cpd'},
                    {header: "{{ 'ClientProductionDetailSystemOut.finish'|trans }}", dataIndex: 'finish', width: 120,alias:'cpd'},
                    {header: "{{ 'ClientProductionDetailSystemOut.opname'|trans }}", dataIndex: 'opname', width: 200,alias:'cpd'},
                    {header: "{{ 'ClientProductionDetailSystemOut.productioncurrent'|trans }}", dataIndex: 'productioncurrent', width: 80,alias:'cpd', align:'right'},
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.textField({
                        title: "{{ 'ClientProductionDetailSystemOut.tip'|trans }}",
                        dataIndex: 'tip',
                        maxLength: 50,
                        labelWidth : '80px',
                        width:140,
                        grid: 's4 m2',
                        disabled:true
                    }),
                    new mj.form.combo({
                        title: "{{ 'ClientProductionDetailSystemOut.client'|trans }}",
                        placeHolder: "{{ 'ClientProductionDetailSystemOut.client_placeholder'|trans }}",
                        dataIndex: 'client',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '80px',
                        grid: 's6 m4',
                        store: t.extras.clients
                    }),
                    new mj.form.dateField({
                        title: "{{ 'ClientProductionDetailSystemOut.day'|trans }}",
                        dataIndex: 'day',
                        labelWidth : '80px',
                        notEmpty: true,
                        width:80,
                        grid: 's4 m2'
                    }),
                    new mj.form.combo({
                        title: "{{ 'ClientProductionDetailSystemOut.jobrotation'|trans }}",
                        placeHolder: "{{ 'ClientProductionDetailSystemOut.jobrotation_placeholder'|trans }}",
                        dataIndex: 'jobrotation',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '80px',
                        grid: 's6 m4',
                        store: t.extras.job_rotations
                    }),
                    new mj.form.dateField({
                        title: "{{ 'ClientProductionDetailSystemOut.start'|trans }}",
                        dataIndex: 'start_d',
                        labelWidth : '80px',
                        notEmpty: true,
                        width:80,
                        //maxLength: 19,
                        grid: 's4 m2'
                    }),
                    new mj.form.timeField2({
                        title: "",
                        dataIndex: 'start_t',
                        notEmpty: true,
                        labelWidth : '10px',
                        grid: 's12 m6',
                        width:50,
                        right:true
                    }),
                    new mj.form.dateField({
                        title: "{{ 'ClientProductionDetailSystemOut.finish'|trans }}",
                        dataIndex: 'finish_d',
                        labelWidth : '80px',
                        width:80,
                        //maxLength: 19,
                        grid: 's4 m2'
                    }),
                    new mj.form.timeField2({
                        title: "",
                        dataIndex: 'finish_t',
                        notEmpty: true,
                        labelWidth : '10px',
                        grid: 's12 m6',
                        width:50,
                        right:true
                    }),
                    new mj.form.combo({
                        title: "{{ 'ClientProductionDetailSystemOut.employee'|trans }}",
                        placeHolder: "{{ 'ClientProductionDetailSystemOut.employee_placeholder'|trans }}",
                        dataIndex: 'employee',
                        mode: 'local',
                        width:200,
                        sameValueDisplay:false,
                        clearOnTriggerClick: true,
                        labelWidth : '80px',
                        grid: 's6 m4',
                        store: t.extras.employees
                    }),
                    new mj.form.combo({
                        title: "{{ 'ClientProductionDetailSystemOut.opname'|trans }}",
                        placeHolder: "{{ 'ClientProductionDetailSystemOut.opname_placeholder'|trans }}",
                        dataIndex: 'opname',
                        mode: 'remote',
                        width:200,
                        clearOnTriggerClick: true,
                        labelWidth : '80px',
                        grid: 's12 m6',
                        store: t.stores.ProductTree
                    }),
                    new mj.form.numberField({
                        title: "{{ 'ClientProductionDetailSystemOut.productioncurrent'|trans }}",
                        dataIndex: 'productioncurrent',
                        maxLength: 5,
                        width:50,
                        labelWidth : '80px',
                        notEmpty: true,
                        grid: 's12 m6'
                    })
                ]
            };
            t._setFormConfig(formConfig);
            /*t.grids.main.on('rowclick',function(g,s){
                var d = g.selectedRow.data;
                var mRight = parseInt(d.sec)>0?0:1;
                d.sec=mRight;
                var _x=$('.mj-checkbox',g.selectedRow.el);
                if(_x.hasClass('mj-checkbox-checked')){
                    _x.removeClass('mj-checkbox-checked');
                }else{
                    _x.addClass('mj-checkbox-checked');
                }
            });
            t.grids.main.on('cellclick',function(g,ri,ci,ce){
                t.grids.main.selectedRow.data = t.grids.main.store.data[ri];
				var idx = parseInt(t.grids.main.store.data[ri].id);
				if(ci==1){//seç
					var mRight = parseInt(t.grids.main.store.data[ri].sec)>0?0:1;
					t.grids.main.store.data[ri].sec=mRight;
                    var _x=$('.mj-checkbox',ce);
                    if(_x.hasClass('mj-checkbox-checked')){
                        _x.removeClass('mj-checkbox-checked');
                    }else{
                        _x.addClass('mj-checkbox-checked');
                    }
				}
			});*/
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                    var data = f.getValue();
                    if(data.client==null||data.client==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientProductionDetailSystemOut.errnotfoundclient'|trans }}");
                        return;
                    }
                    if(data.day==null||data.day==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientProductionDetailSystemOut.errnotfoundday'|trans }}");
                        return;
                    }
                    if(data.jobrotation==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientProductionDetailSystemOut.errnotfoundjobrotation'|trans }}");
                        return;
                    }
                    if(data.start_d==null||data.start_t==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientProductionDetailSystemOut.errnotfoundstart'|trans }}");
                        return;
                    }
                    if(data.finish_d==null||data.finish_t==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientProductionDetailSystemOut.errnotfoundfinish'|trans }}");
                        return;
                    }
                                 
                    //if(flag){
                    var id = data.id;
                    var versionField = f.getField('version');
                    var version = typeof versionField != "undefined" ? data.version : 0;
                    var mode = id ? 'update' : 'add';
                    var routeName = f.modulename + '-' + mode;
                    var route = Routing.getRoute(routeName);
                    var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                        'pg': t.grids.main.pbar.current,
                        'lm': t.grids.main.pbar.limit
                    } : {};
                    var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                        'id': id,
                        'v': version
                    }) : pagerParams);
                    
                    data.menuId = t.id;
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t._event='save';
                        $.ajax({
                            url: url,
                            method: "POST",
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            data: JSON.stringify(data),
                            dataType: 'json',
                            success: function(data, textStatus, jqXHR) {
                                t.reset(_f, data);
                                //t.activateTabGrid();
                                //t.waitMaskHide();
                            },
                            error: function(jqXHR, textStatus, errorThrown) {
                                t.waitMaskHide();
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                    type: "error",
                                    html: true
                                });
                            },
                            complete: function(jqXHR, textStatus) {
                                //t.waitMaskHide();
                            }
                        });
                    }
                    //}else{
                    //    t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                    //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
